'*******************************************************************************
'Display Driver IC ILI9325D 240x320 Pixel
'Modus 8Bit or 16Bit
'Landscape or Portrait
'
'Bascom version 2.0.7.6
'Date 12.06.2013
'
'Autor: Hkipnik@aol.com
'
'Copyright by Hkipnik@aol.com
'
'*******************************************************************************

$nocompile


#if Sd_card = 1
Sub Lcd_draw_bmp(byval Filename As String , Byval Xpos As Word , Byval Ypos As Word)

      Local X As Word
      Local Line_len As Word
      Local Y As Single , Z As Word , Line_count As Word
      Local Bmp_read_pos As Long
      Local Xad As Word
      Local Xadd As Word
      Local Yad As Word
      Local Yadd As Word

      Local Bftype As Word
      Local Bfsize As Long
      Local Bfoffbits As Long
      Local Bisize As Long
      Dim Biwidth As Word                                   'normaly long, but we can't handle bigger bmp's!
      Dim Biheight As Word                                  'normaly long, but we can't handle bigger bmp's!
      Local Biplanes As Word
      Local Bibitcount As Word
      Local Bicompression As Long
      Local Bisizeimage As Long
      Local Bixpelspermeter As Long
      Local Biypelspermeter As Long
      Local Biclrused As Long
      Local Biclrimportant As Long

      Reset Mmc_cs
      Open Filename For Binary As #10


      Get #10 , Bftype , &H01                               '&H00 + 1
      Get #10 , Bfsize , &H03                               '&H02 + 1
      Get #10 , Bfoffbits , &H0B                            '&H0A + 1
      Get #10 , Bisize , &H0F                               '&H0E + 1
      Get #10 , Biwidth , &H013                             '&H12 + 1
      Get #10 , Biheight , &H017                            '&H16 + 1
      Get #10 , Biplanes , &H1B                             '&H1A + 1
      Get #10 , Bibitcount , &H1D                           '&H1C + 1
      Get #10 , Bicompression , &H1F                        '&H1E + 1
      Get #10 , Bisizeimage , &H23                          '&H22 + 1
      Get #10 , Bixpelspermeter , &H27                      '&H26 + 1
      Get #10 , Biypelspermeter , &H2B                      '&H2A + 1
      Get #10 , Biclrused , &H2F                            '&H2E + 1
      Get #10 , Biclrimportant , &H33                       '&H32 + 1


    If Display_modus = 2 Then
       Call Ili9325_write_reg(entry_mode , &B0001000000_10_0_000)
      Decr Biheight
      Xad = Xpos + Biwidth
      Xad = 240 - Xad
      Incr Xad
      Xadd = 240 - Xpos
      Yad = Ypos + Biheight
      Yad = 320 - Yad
      Yadd = 320 - Ypos
      Call Ili9325_write_reg(horizontal_add_start_position , Xad)
      Call Ili9325_write_reg(horizontal_add_end_position , Xadd)

      Call Ili9325_write_reg(vertical_add_start_position , Yad)
      Call Ili9325_write_reg(vertical_add_end_position , Yadd)

      Call Ili9325_write_reg(horizontal_gram_address , Xadd)
      Call Ili9325_write_reg(vertical_gram_address , Yad)
      Call Ili9325_select_reg(write_data_to_gram)
      Incr Biheight
    End If


    If Display_modus = 1 Then
    Call Ili9325_write_reg(entry_mode , &B0001000000_11_1_100)
    Swap Xpos , Ypos
    Xad = Biheight + Xpos
    Yad = Biwidth + Ypos
    Decr Yad
      Call Ili9325_write_reg(horizontal_add_start_position , Xpos)
      Call Ili9325_write_reg(horizontal_add_end_position , Xad)
      Call Ili9325_write_reg(vertical_add_start_position , Ypos)
      Call Ili9325_write_reg(vertical_add_end_position , Yad)

      Call Ili9325_write_reg(horizontal_gram_address , Xpos)
      Call Ili9325_write_reg(vertical_gram_address , Ypos)
      Call Ili9325_select_reg(write_data_to_gram)

    End If

      Config Single = Scientific , Digits = 1

       Incr Biheight
      If Bibitcount = 24 Then
        ' position behind BMP Header Data
        Bmp_read_pos = Bfoffbits + 1
        ' we need line length divideable by 4!
        Line_byte = Biwidth * 3
        Line_len = Biwidth Mod 4
        Line_len = Line_byte + Line_len
        Print "MOD 4  Line-len : " ; Line_len
         Set Rs_disp
         Reset Cs_disp


         !LDS     R30,       {Biheight}                     'Anzahl lines in y-Register
         !LDS     R31,       {Biheight+1}
         !SBIW    R30, 1
         Loop_rows:
           !push    R30
           !push    R31
           Get #10 , Rgb_data(1) , Bmp_read_pos , Line_len

           'THX MWS!!!!
               !LDS     R30,       {Biwidth}                'Anzahl Pixel/line in Z-Register
               !LDS     R31,       {Biwidth+1}

               Loadadr Rgb_data(1) , X

           Loop_line:
               !LD      R16,        X+                      ' blau in R16
               !LD      R17,        X+                      ' gruen in R17
               !LD      R18,        X+                      ' rot in R18
               !ANDI    R18,        &b11111000              ' unnoetiges ausmaskieren

               'GRN
               !ROL     R17                                 ' 4 mal rotieren, da erstes Bit zuerst ins Carry geht
               !ROL     R17
               !ROL     R17
               !ROL     R17                                 ' Bits 7..5 von gruen sind nun an Bit 2..0 fuer Rgb_HB
               !MOV     R24,        R17                     ' nach R24 sichern
               !ROR     R17                                 ' 1 mal aus dem Carry zurck rotieren, um die Bits 4..2 auf 7..5 zu bekommen
               !ANDI    R17,        &b11100000              ' Bit 7..5 von gruen maskieren, fuer Rgb_LB
               !ANDI    R24,        &b00000111              ' Bit 2..0 maskieren fuer Rgb_HB

               'BLAU
               !LSR     R16                                 ' R16, blau 3mal rechts schieben
               !LSR     R16
               !LSR     R16
           #if Driver_mode = 8
               !OR      R24,        R18
               !OUT    Data_disp, R24
               Reset Wr_disp
               Set Wr_disp
               !OR     R17,        R16
               !OUT    Data_disp, R17
               Reset Wr_disp
               Set Wr_disp
           #endif


           #if Driver_mode = 16
               !OR     R17,        R16
               !OUT    Data_disp_low, R17
               !OR     R24,    R18
               !OUT    Data_disp_high, R24
               Reset Wr_disp
               Set Wr_disp
           #endif
               !SBIW  R30, 1                                'decr Z-Register
               !BRNE Loop_line

           Bmp_read_pos = Bmp_read_pos + Line_len

          !pop    R31
          !pop    R30
          !SBIW   R30, 1                                    'decr Z-Register
          !BREq   End_rows
          !Rjmp   Loop_rows
          End_rows:

        Set Cs_disp
      End If

      If Bibitcount = 8 Then
        'load color table
        'Jeder Eintrag der Farbtabelle ist 4 Byte gro und enthlt
        'jeweils ein Byte fr den Blau-, Grn- und Rotanteil, sowie ein auf 0 gesetztes Byte (in dieser Reihenfolge!).
        Bmp_read_pos = 55
        Get #10 , Palette(1) , Bmp_read_pos , 1024

        Line_byte = Biwidth
        Line_len = Line_byte
        Incr Line_len
        Incr Line_len
        ' position behind BMP Header Data
        Bmp_read_pos = Bfoffbits + 1
        Set Rs_disp
        Reset Cs_disp

         Seek #10 , Bmp_read_pos

         !LDS     R30,       {Biheight}                     'Anzahl lines in y-Register
         !LDS     R31,       {Biheight+1}
         !SBIW    R30, 1

         Loop_rows_8:
           !push    R30
           !push    R31

           Get #10 , Rgb_data(1) , , Line_len

           For X = 1 To Line_byte
               'point to palette entry
               Z = 4 * Rgb_data(x)
               'asm von MagicWhiteSmoke  thx!
               Loadadr Palette(z + 1) , X
               !LD      R16,        x+                      ' blau in R16
               !LD      R17,        x+                      ' gruen in R17
               !LD      R18,        x                       ' rot in R18
               !ANDI    R18,        &b11111000              ' unnoetiges ausmaskieren
               'GRN
               !ROL     R17                                 ' 4 mal rotieren, da erstes Bit zuerst ins Carry geht
               !ROL     R17
               !ROL     R17
               !ROL     R17                                 ' Bits 7..5 von gruen sind nun an Bit 2..0 fuer Rgb_HB
               !MOV     R24,        R17                     ' nach R24 sichern
               !ROR     R17                                 ' 1 mal aus dem Carry zurck rotieren, um die Bits 4..2 auf 7..5 zu bekommen
               !ANDI    R17,        &b11100000              ' Bit 7..5 von gruen maskieren, fuer Rgb_LB
               !ANDI    R24,        &b00000111              ' Bit 2..0 maskieren fuer Rgb_HB

               'BLAU
               !LSR     R16                                 ' R16, blau 3mal rechts schieben
               !LSR     R16
               !LSR     R16


             #if Driver_mode = 8
               !OR      R24,        R18
               !OUT    Data_disp, R24
               Reset Wr_disp
               Set Wr_disp
               !OR     R17,        R16
               !OUT    Data_disp, R17
               Reset Wr_disp
               Set Wr_disp
             #endif

             #if Driver_mode = 16
               !OR      R24,        R18
               !OUT    Data_disp_low, R24
               !OR     R17,        R16                      ' mit bereits vorhanden Bits in Rgb_LB verodern
               !OUT    Data_disp_high, R17
               Reset Wr_disp
               Set Wr_disp
             #endif
           Next
        !pop    R31
        !pop    R30
        !SBIW   R30, 1                                      'decr Z-Register
        !BREq   End_bmp8_rows
        !Rjmp   Loop_rows_8
        End_bmp8_rows:

        Set Cs_disp
      End If

      Close #10

   Config Single = Scientific , Digits = 7
   If Display_modus = 2 Then
     Call Ili9325_write_reg(entry_mode , &B0001000000_00_0_000)
    End If
    If Display_modus = 1 Then
    Call Ili9325_write_reg(entry_mode , &B0001000000_10_1_000)
    End If
End Sub
#endif

'*******************************************************************************
' Draw Pic x start -- y start -- Breite -- Hhe from SRAM  Bin file
' before Call Sub you must Restore the Label
'*******************************************************************************
Sub Lcd_pic_sram(byval Xs As Word , Byval Ys As Word , Byval Breite As Word , Byval Height As Word )
  Local Zal As Word , Xe As Word , Yss As Word
  Local R1 As Byte , R2 As Byte
  Local Lang As Word
  Lang = Breite * Height
 If Display_modus = 2 Then
   Call Lcd_set_window(xs , Ys , Breite , Height)
 End If
 If Display_modus = 1 Then
  Swap Xs , Ys
  Yss = 319 - Breite
  Yss = Yss - Ys
  Incr Yss
  Incr Yss
  Incr Yss
  Call Lcd_set_window(xs , Yss , Height , Breite)
 End If
 Cs_disp = 0
 Rs_disp = 1
#if Driver_mode = 8
  For Zal = 1 To Lang
    Read R1
    Read R2
     Data_disp = R1
     Wr_disp = 0
     Wr_disp = 1
     Data_disp = R2
     Wr_disp = 0
     Wr_disp = 1
  Next
#endif
#if Driver_mode = 16
  For Zal = 1 To Lang
    Read R1
    Read R2
     Data_disp_low = R1
     Data_disp_high = R2
     Wr_disp = 0
     Wr_disp = 1
  Next
#endif
   Cs_disp = 1

End Sub

'-------------------------------------------------------------------------------
' Ili9325_scroll
'-------------------------------------------------------------------------------
Sub Lcd_scroll(byval Lines As Word )
     Call Ili9325_write_reg(base_image_display_control , &B0000_0000_0000_0011 )
     Call Ili9325_write_reg(vertical_scroll_control , Lines)
End Sub


'-------------------------------------------------------------------------------
' Ili9325_set_window Set Window Area to write
'-------------------------------------------------------------------------------
Sub Lcd_set_window(byval Xpos As Word , Byval Ypos As Word , Byval Xsize As Word , Byval Ysize As Word)
     Local X_add As Word , Y_add As Word

     Y_add = Y_pixel - Ypos
     Ypos = Y_add - Ysize
     X_add = X_pixel - Xpos
     Xpos = X_add - Xsize

     Incr Xpos
     Incr Ypos

     Call Ili9325_write_reg(horizontal_add_start_position , Xpos)       ' Horizontal GRAM Start Address-----HSA[7:0]
     Call Ili9325_write_reg(horizontal_add_end_position , X_add)       ' Horizontal GRAM End Address-----HEA[7:0]
     Call Ili9325_write_reg(vertical_add_start_position , Ypos)       'Vertical GRAM Start Address-----VSA[8:0]
     Call Ili9325_write_reg(vertical_add_end_position , Y_add)       'Vertical GRAM Start Address-----VEA[8:0]

     Call Ili9325_write_reg(horizontal_gram_address , X_add)

  If Display_modus = 2 Then
     Call Ili9325_write_reg(vertical_gram_address , Y_add)  'modus2
   Else
     Call Ili9325_write_reg(vertical_gram_address , Ypos)
  End If
     Call Ili9325_select_reg(write_data_to_gram)
End Sub


'-------------------------------------------------------------------------------
' Ili9325_negate   art=0 -> negative  art=1 -> normal
'-------------------------------------------------------------------------------
Sub Lcd_negate(byval Art As Word )
     If Art = 1 Then
        Art = 1
     Else
        Art = 0
     End If
     Call Ili9325_write_reg(base_image_display_control , Art )
End Sub


'-------------------------------------------------------------------------------
' ILI9325_set_pixel  Set one Pixel in given color
'-------------------------------------------------------------------------------
Sub Lcd_set_pixel(byval X1 As Word , Y1 As Word , Color As Word)
   Call Lcd_set_cursor(x1 , Y1)
   Call Ili9325_write_reg(write_data_to_gram , Color)
End Sub

'-------------------------------------------------------------------------------
' ILI9325_Set_Cursor(X, Y)     1-240; 1-320
'-------------------------------------------------------------------------------
Sub Lcd_set_cursor(byval X As Word , Y As Word )
   If Display_modus = 1 Then
      Swap X , Y
      X = X_pixel - X
   End If
   If Display_modus = 2 Then
      X = X_pixel - X
      Y = Y_pixel - Y
   End If
   Call Ili9325_write_reg(horizontal_gram_address , X)
   Call Ili9325_write_reg(vertical_gram_address , Y)
End Sub
'-------------------------------------------------------------------------------
'Text
'-------------------------------------------------------------------------------
Sub Lcd_text(byval S As String , Xoffset As Word , Yoffset As Word , Fontset As Byte , Forecolor As Word , Backcolor As Word )
    Local Tempstring As String * 1 , Temp As Word           'Dim local the variables
    Local A As Word , Pixels As Byte , Count As Byte , Carcount As Byte , Lus As Byte
    Local Row As Byte , Block As Byte , Byteseach As Byte , Blocksize As Byte , Dummy As Byte
    Local Colums As Byte , Columcount As Byte , Rowcount As Byte , Stringsize As Byte
    Local Xpos As Word , Ypos As Word , Pixel As Word , Pixelcount As Byte
    Local Offset As Word

   Stringsize = Len(s) - 1                                  'Size of the text string -1 because we must start with 0
    Select Case Fontset
      Case 1 :
         Block = Lookup(0 , Font8x8)                        'Add or remove here fontset's that you need or not,
         Byteseach = Lookup(1 , Font8x8)
         Blocksize = Lookup(2 , Font8x8)
         Dummy = Lookup(3 , Font8x8)
      Case 2 :
         Block = Lookup(0 , Font12x16)
         Byteseach = Lookup(1 , Font12x16)
         Blocksize = Lookup(2 , Font12x16)
         Dummy = Lookup(3 , Font12x16)
    '(
      Case 3 :
         Block = Lookup(0 , Font25x32)
         Byteseach = Lookup(1 , Font25x32)
         Blocksize = Lookup(2 , Font25x32)
         Dummy = Lookup(3 , Font25x32)
      Case 4 :
         Block = Lookup(0 , Cr16x32)
         Byteseach = Lookup(1 , Cr16x32)
         Blocksize = Lookup(2 , Cr16x32)
         Dummy = Lookup(3 , Cr16x32)
      Case 5 :
         Block = Lookup(0 , Cr20x40)
         Byteseach = Lookup(1 , Cr20x40)
         Blocksize = Lookup(2 , Cr20x40)
         Dummy = Lookup(3 , Cr20x40)
      Case 6 :
         Block = Lookup(0 , Cn9x16)
         Byteseach = Lookup(1 , Cn9x16)
         Blocksize = Lookup(2 , Cn9x16)
         Dummy = Lookup(3 , Cn9x16)
')
   End Select
   Colums = Blocksize / Block                               'Calculate the numbers of colums
   Row = Block * 8                                          'Row is always 8 pixels high = 1 byte, so working with row in steps of 8.
   Row = Row - 1                                            'Want to start with row=0 instead of 1
   Colums = Colums - 1                                      'Same for the colums
   For Carcount = 0 To Stringsize                           'Loop for the numbers of caracters that must be displayed
      Temp = Carcount + 1                                   'Cut the text string in seperate caracters
      Tempstring = Mid(s , Temp , 1)
      Offset = Asc(tempstring) - 32                         'Font files start with caracter 32
      Offset = Offset * Blocksize
      Offset = Offset + 4
      Temp = Carcount * Byteseach
      Temp = Temp + Xoffset
      For Rowcount = 0 To Row Step 8                        'Loop for numbers of rows
          A = Rowcount + Yoffset
          Xpos = Temp
          For Columcount = 0 To Colums                      'Loop for numbers of Colums
             Select Case Fontset
                Case 1 : Pixels = Lookup(offset , Font8x8)
                Case 2 : Pixels = Lookup(offset , Font12x16)
               ' Case 3 : Pixels = Lookup(offset , Font25x32)
               ' Case 4 : Pixels = Lookup(offset , Cr16x32 )
               ' Case 5 : Pixels = Lookup(offset , Cr20x40 )
               ' Case 6 : Pixels = Lookup(offset , Cn9x16 )
             End Select
             Ypos = A
              For Pixelcount = 0 To 7                       'Loop for 8 pixels to be set or not
                  Pixel = Pixels.0                          'Set the pixel (or not)
                  If Pixel = 1 Then
                     Pixel = Forecolor
                  Else
                      Pixel = Backcolor
                  End If
                  If Pixel <> Transparent Then
                     Call Lcd_set_pixel(xpos , Ypos , Pixel)
                  End If
                  Shift Pixels , Right                      'Shift the byte 1 bit to the right so the next pixel comes availible
                  Incr Ypos                                 'Each pixel on his own spot
              Next Pixelcount
             Incr Offset
             Incr Xpos                                      'Do some calculation to get the caracter on the correct Xposition
          Next Columcount
      Next Rowcount
   Next Carcount
End Sub
'*******************************************************************************
' Text rotation test
'*******************************************************************************
Sub Lcdtext(byval S As String , Byval Xoffset As Word , Byval Yoffset As Word , Byval Forecolor As Word , Byval Backcolor As Word , Byval Rotation As Byte , Byval Fontset As Byte)
   Local Tempstring As String * 1 , Temp As Word
   Local A As Word , Pixels As Byte , Pixels_adress As Word , Carcount As Byte
   Local Columcount As Byte , Rowcount As Byte , Stringsize As Byte
   Local Xpos As Word , Ypos As Word , Pixel As Word , Pixelcount As Byte
   Local Dummy_word As Word
   Local Row As Byte , Colums As Byte , Byteseach As Byte , Blocksize As Word
   Local Font_adress As Word
   Local Rows As Word
   Local Rest As Word , Restt As Word

   Select Case Fontset                                      ' You may use case 1, case 2 etc insted of alias names
      Case 1 : Font_adress = Loadlabel(font8x8)             'This is the name that you gave to the font, NOT the filename
      Case 2 : Font_adress = Loadlabel(font12x16)
      Case 3 : Font_adress = Loadlabel(font25x32)
      Case 4 : Font_adress = Loadlabel(crn20x24)
   End Select
   ' --- Load font info needed for Lcdtext subroutine calculations ---
   Dummy_word = Font_adress : Row = Cpeek(dummy_word)
   Incr Dummy_word : Byteseach = Cpeek(dummy_word)
   Incr Dummy_word : Blocksize = Cpeek(dummy_word)
   ' -----
 '  Print "Row= " ; Row
 '  Print "Bytes= " ; Byteseach
 '  Print "Block= " ; Blocksize

   Rows = Blocksize
   Rows = Rows / 8
   Rows = Rows + Row
   Colums = Blocksize / Row                                 'Calculate the numbers of colums
   Row = Row * 8                                            'Row is always 8 pixels high = 1 byte, so working with row in steps of 8.
   Row = Row - 1                                            'Want to start with row=0 instead of 1
   Colums = Colums - 1                                      'Same for the colums
   Font_adress = Font_adress + 4                            'Skip first 4 bytes in fontfile

   If Rotation > 3 Then Rotation = 0                        'There are only 4 rotation's
   Stringsize = Len(s) - 1                                  'Size of the text string -1 because we must start with 0

   For Carcount = 0 To Stringsize                           'Loop for the numbers of caracters that must be displayed
      Temp = Carcount + 1                                   'Cut the text string in seperate caracters
      Tempstring = Mid(s , Temp , 1)
      Temp = Asc(tempstring) - 32                           'Font files start with caracter 32
      Dummy_word = Blocksize * Temp
      Pixels_adress = Font_adress + Dummy_word              'Do dummie read to point to the correct line in the fontfile
      Temp = Carcount * Byteseach                           'Do first part of calculation to get the character on the correct X or Y position
      Select Case Rotation
          Case 0 :                                          '0 degrees rotation
                  Temp = Temp + Xoffset
                  For Rowcount = 0 To Row Step 8            'Loop for numbers of Row
                        A = Rowcount + Yoffset
                        For Columcount = 0 To Colums        'Loop for numbers of Colums
                            Pixels = Cpeek(pixels_adress)
                            Incr Pixels_adress
                            Xpos = Columcount
                            Xpos = Xpos + Temp              'Do rest of calculation to get the character on the correct X position
                            For Pixelcount = 0 To 7         'Loop for 8 pixels to be set or not
                              Ypos = A + Pixelcount         'Each pixel on his own spot
                              Pixel = Pixels.pixelcount     'Set the pixel (or not)
                              If Pixel = 1 Then
                                Pixel = Forecolor
                              Else
                                Pixel = Backcolor
                              End If
                            If Pixel <> Transparent Then
                               Call Lcd_set_pixel(xpos , Ypos , Pixel)
                            End If
                            Next Pixel
                        Next Columcount
                  Next Rowcount
          Case 1 :                                          '90 degrees rotation
                  For Rowcount = Row To 0 Step -8           'Loop is now counting down
                        A = Rowcount + Xoffset
                        For Columcount = 0 To Colums
                            Pixels = Cpeek(pixels_adress)
                            Incr Pixels_adress
                            Xpos = Columcount
                            Xpos = Xpos + Yoffset
                            Xpos = Xpos + Temp
                            For Pixelcount = 7 To 0 Step -1
                              Ypos = A + Pixelcount
                              Pixel = Pixels.0
                               If Pixel = 1 Then
                                Pixel = Forecolor
                              Else
                                Pixel = Backcolor
                              End If
                            If Pixel <> Transparent Then
                               Call Lcd_set_pixel(ypos , Xpos , Pixel)
                            End If
                              Shift Pixels , Right
                            Next Pixel
                        Next Columcount
                  Next Rowcount
          Case 2 :                                          '180 degrees rotation
                  For Rowcount = Row To 0 Step -8
                        A = Rowcount + Yoffset
                        For Columcount = Colums To 0 Step -1
                            Pixels = Cpeek(pixels_adress)
                            Incr Pixels_adress
                            Xpos = Columcount
                            Xpos = Xpos - Temp
                            Xpos = Xpos - 8
                            Xpos = Xpos + Xoffset
                            For Pixelcount = 7 To 0 Step -1
                                Ypos = A + Pixelcount
                                Pixel = Pixels.0
                                 If Pixel = 1 Then
                                Pixel = Forecolor
                              Else
                                Pixel = Backcolor
                              End If
                            If Pixel <> Transparent Then
                               Call Lcd_set_pixel(xpos , Ypos , Pixel)
                            End If
                                Shift Pixels , Right
                            Next Pixel
                        Next Columcount
                  Next Rowcount
          Case 3 :                                          '270 degrees rotation
                  For Rowcount = 0 To Row Step 8
                        A = Rowcount + Xoffset
                          For Columcount = Colums To 0 Step -1
                            Pixels = Cpeek(pixels_adress)
                            Incr Pixels_adress
                            Xpos = Columcount
                            Xpos = Xpos - Temp
                            Xpos = Xpos - 8
                            Xpos = Xpos + Yoffset
                            Xpos = Xpos - Rows              '555
                            For Pixelcount = 0 To 7
                                Ypos = A + Pixelcount
                                Pixel = Pixels.pixelcount
                                 If Pixel = 1 Then
                                   Pixel = Forecolor
                                 Else
                                   Pixel = Backcolor
                                 End If
                                If Pixel <> Transparent Then
                                  Call Lcd_set_pixel(ypos , Xpos , Pixel)
                                 End If
                            Next Pixel
                        Next Columcount
                  Next Rowcount
      End Select
   Next Carcount
End Sub


'-------------------------------------------------------------------------------
' ILI9325_line pixel line   left-top (x1,y1) right-bottom(x2,y2),
'                           Pen Width in Pixel(byte), color($0000-$FFFF)
'-------------------------------------------------------------------------------
Sub Lcd_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Pen_width As Byte , Byval Color As Word)
   Local Y As Word , X As Word , X_diff As Single , Y_diff As Single , Pos As Word
   Local X_factor As Single , X_pos As Word , Y_pos As Word , Base As Word , Pen_count As Byte

 '  If X1 > X_pixel Then X1 = X_pixel
  ' If X2 > X_pixel Then X2 = X_pixel
  ' If Y1 > Y_pixel Then Y1 = Y_pixel
  ' If Y2 > Y_pixel Then Y2 = Y_pixel
   Y_diff = Y2 - Y1
   X_diff = X2 - X1
   Pos = 0

   X_factor = Abs(y_diff)
   Y = X_factor
   X_factor = Abs(x_diff)
   X = X_factor

   If Y > X Then
      X_factor = X_diff / Y_diff
      If Y1 > Y2 Then
         Swap Y1 , Y2
         Base = X2
      Else
         Base = X1
      End If
      For Y = Y1 To Y2
         X_diff = Pos * X_factor
         X_pos = X_diff
         X_pos = X_pos + Base
         Call Lcd_set_pixel(x_pos , Y , Color)
         For Pen_count = 2 To Pen_width
             Call Ili9325_write_data(color)
         Next Pen_count
         Incr Pos
      Next Y
   Else
      X_factor = Y_diff / X_diff
      If X1 > X2 Then
          Swap X1 , X2
         Base = Y2
      Else
         Base = Y1
      End If
      For X = X1 To X2
         Y_diff = Pos * X_factor
         Y_pos = Y_diff
         Y_pos = Y_pos + Base
         Call Lcd_set_pixel(x , Y_pos , Color)
         For Pen_count = 2 To Pen_width
             Call Ili9325_write_data(color)
         Next Pen_count
         Incr Pos
      Next X
   End If
End Sub


'-------------------------------------------------------------------------------
' ILI9325_box  left-top (x1,y1) right-bottom(x2,y2)
'              Fill_color, Border_color $0000-$ffff
'              fill > 0  , Show_border > 0
'-------------------------------------------------------------------------------
Sub Lcd_box(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Fill_color As Word , Byval Border_color As Word , Byval Fill As Byte , Byval Show_border As Byte)
    Local X_counter As Word , Y_counter As Word , X_pos1 As Word , X_pos2 As Word
   If X1 > X2 Then Swap X1 , X2
    If Y1 > Y2 Then Swap Y1 , Y2

    If Show_border > 0 Then
      Call Lcd_line(x1 , Y1 , X2 , Y1 , 1 , Border_color)
      Call Lcd_line(x1 , Y2 , X2 , Y2 , 1 , Border_color)
      Incr Y1
      Decr Y2
    Else
      X_pos1 = X1
      X_pos2 = X2 - 1
    End If
    For Y_counter = Y1 To Y2
        If Show_border > 0 Then
          Call Lcd_set_pixel(x1 , Y_counter , Border_color)
        End If
        If Fill > 0 Then
          If Show_border > 0 Then
            X_pos1 = X1 + 1
            X_pos2 = X2 - 1
          Else
            Call Lcd_set_pixel(x1 , Y_counter , Fill_color)
          End If

          For X_counter = X_pos1 To X_pos2
             Call Lcd_set_pixel(x_counter , Y_counter , Fill_color)
          Next X_counter
          If Show_border > 0 Then
             Call Ili9325_write_data(border_color)
          End If
        Else
          If Show_border > 0 Then
            Call Lcd_set_pixel(x2 , Y_counter , Border_color)
          End If
        End If
    Next                                                    'Line_counter
End Sub

'-------------------------------------------------------------------------------
' ILI9325_Lineto  x,y screen pos, pen width, color border
'-------------------------------------------------------------------------------
Sub Lcd_lineto(byval X As Word , Byval Y As Word , Byval Pen_width As Byte , Byval Color As Word , Byval Fill As Byte)
    Call Lcd_line(move_x , Move_y , X , Y , Pen_width , Color )
    If Fill = 1 Then
    Call Lcd_line(move_x , Move_y , Center , Move_y , Pen_width , Color )
   End If
    Move_x = X
    Move_y = Y
End Sub


'-------------------------------------------------------------------------------
' ILI9325_Moveto  x,y screen pos
'-------------------------------------------------------------------------------
Sub Lcd_moveto(byval X As Word , Byval Y As Word)

    If Display_modus = 2 Then
      Y = Y_pixel - Y
    End If
    Call Lcd_set_cursor(x , Y)
    Move_x = X
    Move_y = Y
End Sub

'-------------------------------------------------------------------------------
' Lcd show BGC File  X Start  Y Start
' Important that you first RESTORE the image before calling this sub
'-------------------------------------------------------------------------------
Sub Lcd_show_bgc(byval Xoffset As Word , Byval Yoffset As Word)

Local Ysize As Byte , Xsize As Byte
Local Imagesize As Word
Local L As Word , Pixel As Byte ,
Local Pixelword As Word , Prevpixel As Word , Repeat As Byte
Local X1size As Word , Y1size As Word , Yss As Word


Read Ysize                                                  'Read the first 4 bytes from the BGC, this contains info about the image
Read Xsize
Read Imagesize                                              'Byte 3&4 contains the image size

X1size = Xsize
Y1size = Ysize

'Bit B7  Page Address Order 0 = Top to Bottom 1 = Bottom to Top
'Bit B6  Column Address Order 0 = Left to Right 1 = Right to Left
'Bit B5  Page/Column Order 0 = Normal Mode 1 = Reverse Mode
'Bit B4  Line Address Order 0 = LCD Refresh Top to Bottom 1 = LCD Refresh Bottom to Top
'Bit B3  RGB/BGR Order 0 = Pixels sent in RGB order 1 = Pixels sent in BGR order
'Bit B2  Display Data Latch Data Order Not applicable, so it is set to 0.
'Bit B1  Horizontal Flip 0 = Normal display 1 = Flipped display
'Bit B0  Vertical Flip 0 = Normal display 1 = Flipped display


If Display_modus = 1 Then
  Swap Xoffset , Yoffset
  Yss = 320 - Xsize
  Yss = Yss - Yoffset
  Call Lcd_set_window(xoffset , Yss , Y1size , X1size)
 End If
If Display_modus = 2 Then
 Call Lcd_set_window(xoffset , Yoffset , X1size , Y1size)
End If

Do
Read Pixel                                                  'Read the value for the pixel
    If Pixel = &HAA Then                                    'BGC file is rle coded &HAA represents this, the byte after &HAA is the number of times that the byte before &HAA wil be repeated
     Read Repeat                                            'Byte after &HAA contains the number of times to repeat
     Repeat = Repeat - 1
      For L = 1 To Repeat                                   'Loop the repeat
          Call Ili9325_write_data(prevpixel)                'Write the pixel data to the display
          Decr Imagesize                                    'Decrease the bytes still to be processed
      Next L                                                'Next repeat loop
   Else                                                     'It's a regular byte, not LRE encoded
      Pixelword = Rgb_16(pixel)                             'Convert the 8bit pixel to 16bit pixel
      Call Ili9325_write_data(pixelword)                    'Write the pixel data to the display
      Prevpixel = Pixelword                                 'Store the pixel in a temp word, maybe we need it if the next byte is &HAA
      Decr Imagesize                                        'Decrease the bytes still to be processed
   End If
Loop Until Imagesize = 0                                    'Do until all bytes are processed

End Sub

'-------------------------------------------------------------------------------
' ILI9325_Clear Clear LCD with color
'-------------------------------------------------------------------------------
Sub Lcd_clear(byval Color As Word)
   Local Ili9325_count_color As Long
   Local Highd As Byte , Lowd As Byte

   Call Lcd_set_window(1 , 1 , X_pixel , Y_pixel)
   Highd = High(color)
   Lowd = Low(color)
   Cs_disp = 0
   Rs_disp = 1
#if Driver_mode = 8
   For Ili9325_count_color = 1 To 76800
     Data_disp = Highd                                      'High(color)
     nop
     Wr_disp = 0
     nop
     Wr_disp = 1
     Data_disp = Lowd                                       ' Low(color)
     nop
     Wr_disp = 0
     nop
     Wr_disp = 1
   Next
#endif
#if Driver_mode = 16
   For Ili9325_count_color = 1 To 76800
     Data_disp_high = Highd                                 'High(color)

     Data_disp_low = Lowd                                   ' Low(color)
     Wr_disp = 0
     Wr_disp = 1
   Next
#endif

   Cs_disp = 1
End Sub

'*******************************************************************************
'Convert the 8bit RRRGGGBB bgc data to 16 bit RRRRRGGGGGGBBBBB
'*******************************************************************************
Function Rgb_16(byval Rgb8 As Byte) As Word
Local Rd8 As Byte , Gr8 As Byte , Bl8 As Byte
Local Rd16 As Word , Gr16 As Word , Bl16 As Word , Tempword As Word
Bl8 = Rgb8 And &B00000011                                   'Exctract the blue bits from the byte
Shift Rgb8 , Right , 2                                      'Shift the 2 blue bits to heaven
Gr8 = Rgb8 And &B00000111                                   'Exctract the green bits from the byte
Shift Rgb8 , Right , 3                                      'Shift the 3 green bits to heaven
Rd8 = Rgb8 And &B00000111                                   'Exctract the red bits from the byte
Rd16 = Lookup(rd8 , Red16)                                  'look up the conversion in the tables
Gr16 = Lookup(gr8 , Green16)
Bl16 = Lookup(bl8 , Blue16)
Tempword = Rd16                                             'Add the 3 colors together to get the 16bit color
Tempword = Tempword + Gr16
Tempword = Tempword + Bl16
Rgb_16 = Tempword                                           'Give the result back to the function
End Function

'-------------------------------------------------------------------------------
' LCD_circle  centerX, centerY, radius, sides, pen width, color Border , fill
'-------------------------------------------------------------------------------
Sub Lcd_drawcircle(byval Centerx As Word , Byval Centery As Word , Byval Radius As Word , Byval Sides As Word , Byval Pen_width As Byte , Byval Color As Word , Byval Fill As Byte)
    Local I As Word
    Local Pointratio As Single
    Local Xsteps As Single , Ysteps As Single
    Local Pointx As Single , Pointy As Single
    Local X As Word , Y As Word

    Center = Centerx
    I = Centerx + Radius
    Out_of_range = 0
    Call Ili9325_write_reg(horizontal_gram_address , I)
    Call Ili9325_write_reg(vertical_gram_address , Centery)
    Move_x = I
    Move_y = Centery
    Call Ili9325_select_reg(write_data_to_gram)

    For I = 0 To Sides
        Pointratio = I / Sides
        Xsteps = Ili9325_trigfunctionx(pointratio)
        Ysteps = Ili9325_trigfunctiony(pointratio)
        Pointx = Xsteps * Radius
        Pointx = Centerx + Pointx
        X = Pointx
        Pointy = Ysteps * Radius
        Pointy = Centery + Pointy
        Y = Pointy
        If X < X_pixel And Y < Y_pixel Then
           If Out_of_range = 1 Then
              Call Ili9325_write_reg(horizontal_gram_address , X)
              Call Ili9325_write_reg(vertical_gram_address , Y)
                Move_x = X
                Move_y = Y
             Call Ili9325_select_reg(write_data_to_gram)
              Out_of_range = 0
           End If
           Call Lcd_lineto(x , Y , Pen_width , Color , Fill)
        Else
           Out_of_range = 1
        End If
    Next
End Sub


'-------------------------------------------------------------------------------
'LCD Fill Circle etwas schneller als mit LCD_Drawcircle
'-------------------------------------------------------------------------------
Sub Fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)

Local Xy_radius As Integer
Local Zahly As Integer
Local Zahlx As Integer

Local Y1 As Integer
Local X1 As Integer

Local Y11 As Integer
Local X11 As Integer
Local Xy As Integer

Local X2 As Word , Y2 As Word


Xy_radius = Radius * Radius

Y1 = -radius
X1 = -radius

   For Zahly = Y1 To Radius
       Y11 = Zahly * Zahly
    For Zahlx = X1 To Radius
       X11 = Zahlx * Zahlx
       Xy = X11 + Y11
       If Xy <= Xy_radius Then

       X2 = X + Zahlx
       Y2 = Y + Zahly
       Call Lcd_set_pixel(x2 , Y2 , Color1)
       End If
    Next
   Next

End Sub
'-------------------------------------------------------------------------------
' ILI9325_trigfunctionx  calc COS
'-------------------------------------------------------------------------------
Function Ili9325_trigfunctionx(byval Pointratio As Single) As Single
    Pointratio = Pointratio * 2
    Pointratio = Pointratio * Pi
    Ili9325_trigfunctionx = Cos(pointratio)
End Function

'-------------------------------------------------------------------------------
' ILI9325_trigfunctiony calc SIN
'-------------------------------------------------------------------------------
Function Ili9325_trigfunctiony(byval Pointratio As Single) As Single
    Pointratio = Pointratio * 2
    Pointratio = Pointratio * Pi
    Ili9325_trigfunctiony = Sin(pointratio)
End Function
'*******************************************************************************
' Read Touch
'*******************************************************************************
#if Use_touch = 1
Sub Lcd_read_touch()
   Local Tx As Word , Ty As Word
   Local Res As Single

   Clock = 0
   Cst = 0
   Waitms 10
   Shiftout Dout , Clock , X_dout , 1 , 8 , 40
   Waitms 5
   Shiftin Din , Clock , Touchx , 1 , 16 , 40
   Shiftout Dout , Clock , Y_dout , 1 , 8 , 40
   Waitms 5
   Shiftin Din , Clock , Touchy , 1 , 16 , 40
   Cst = 1

   Tx = Touchx And &B0111_1111_1111_1000
   Shift Tx , Right , 3
   Print "x-l1= " ; Tx
   Tx = Tx - X_offset                                       'wert zwischen 1 und 240 zb 478 fr x=1 und 3712 fr x=240  then 3312/ 240 = 13.8
   Res = Tx / X_fact
   Touchx = Int(res)

   Ty = Touchy And &B0111_1111_1111_1000
   Shift Ty , Right , 3
   Print "y-l1= " ; Ty
   Ty = Ty - Y_offset
   Res = Ty / Y_fact
   Touchy = Int(res)

  If Display_modus = 2 Then
     If Touchx > 240 Then Touchx = 0
     If Touchy > 320 Then Touchy = 0
     Touchx = 240 - Touchx
     Touchy = 320 - Touchy
  End If

  If Display_modus = 1 Then
     If Touchx > 240 Then Touchx = 0
     If Touchy > 320 Then Touchy = 0
     Touchx = 240 - Touchx
     Swap Touchx , Touchy
  End If
'  Print "x-l= " ; Touchx
'  Print "Y-l= " ; Touchy
   Waitms 300
   Touch_flag = 0


End Sub
#endif
'-------------------------------------------------------------------------------
' INIT ILI9325 D Display Modus  1=Landscape  2=Portrait
'-------------------------------------------------------------------------------
Sub Ili9325_init(byval Modus As Byte)
'reset
Res_disp = 1
Waitms 5
Res_disp = 0
Waitms 15
Res_disp = 1
Waitms 15

Display_modus = Modus

If Display_modus = 2 Then
Call Ili9325_write_reg(&H01 , &H0000)                       'Portrait
Call Ili9325_write_reg(&H02 , &H0700)                       'driver_output_control H0000
X_pixel = 240
Y_pixel = 320
Call Ili9325_write_reg(entry_mode , &B0001000000_00_0_000)
End If

If Display_modus = 1 Then
Call Ili9325_write_reg(&H01 , &H0000)                       'Landscape
Call Ili9325_write_reg(&H02 , &H0700)                       'driver_output_control  H0000
X_pixel = 240
Y_pixel = 320
Call Ili9325_write_reg(entry_mode , &B0001000000_10_1_000)
End If


Call Ili9325_write_reg(&He5 , &H7800)                       'SRAM internal timing
Call Ili9325_write_reg(&H04 , &H0000)                       'resize register

Call Ili9325_write_reg(&H08 , &H0207)                       'set the back porch and the front porch
Call Ili9325_write_reg(&H09 , &H0000)                       'set non-display area refresh cycle ISC[3:0]
Call Ili9325_write_reg(&H0a , &H0000)                       'FMARK function
Call Ili9325_write_reg(&H0c , &H0000)                       'RGB interface settings
Call Ili9325_write_reg(&H0d , &H0000)                       '   'frame marker position
Call Ili9325_write_reg(&H0f , &H0000)                       'RGB interface polarity
'
Call Ili9325_write_reg(&H10 , &H0000)                       'SAP, BT[3:0], AP, DSTB, SLP, STB
Call Ili9325_write_reg(&H11 , &H0007)                       'DC1[2:0], DC0[2:0], VC[2:0]
Call Ili9325_write_reg(&H12 , &H0000)                       'VREG1OUT voltage
Call Ili9325_write_reg(&H13 , &H0000)                       'VDV[4:0] for VCOM amplitude
'
Call Ili9325_write_reg(&H07 , &H0001)                       'discharge capacitor power voltage
Waitms 50

Call Ili9325_write_reg(&H10 , &H1090)                       '1490/SAP, BT[3:0], AP, DSTB, SLP, STB 1590 1290 1690  1090
Call Ili9325_write_reg(&H11 , &H0227)                       'DC1[2:0], DC0[2:0], VC[2:0]
Waitms 200
Call Ili9325_write_reg(&H12 , &H001F)                       'internal reference voltage   0d
Waitms 200
Call Ili9325_write_reg(&H13 , &H1500)                       '1200
Call Ili9325_write_reg(&H29 , &H0027)                       '000a
'
Call Ili9325_write_reg(&H2b , &H000D)
Waitms 50

Call Ili9325_write_reg(&H20 , &H0000)
Call Ili9325_write_reg(&H21 , &H0000)

'(
Call Ili9325_write_reg(&H10 , &H1690)                       '1490/SAP, BT[3:0], AP, DSTB, SLP, STB   1690
Call Ili9325_write_reg(&H11 , &H0227)                       'DC1[2:0], DC0[2:0], VC[2:0]
Waitms 200
Call Ili9325_write_reg(&H12 , &H001F)                       'internal reference voltage   0d
Waitms 200
Call Ili9325_write_reg(&H13 , &H1200)                       '1200
Call Ili9325_write_reg(&H29 , &H000A)                       '000a
'
Call Ili9325_write_reg(&H2b , &H000D)
Waitms 50
'
Call Ili9325_write_reg(&H20 , &H0000)
Call Ili9325_write_reg(&H21 , &H0000)
')
'(
Call Ili9325_write_reg(&H30 , &H0000)
Call Ili9325_write_reg(&H31 , &H0507)
Call Ili9325_write_reg(&H32 , &H0307)
Call Ili9325_write_reg(&H35 , &H0200)
Call Ili9325_write_reg(&H36 , &H0008)
Call Ili9325_write_reg(&H37 , &H0004)
Call Ili9325_write_reg(&H38 , &H0000)
Call Ili9325_write_reg(&H39 , &H0707)
Call Ili9325_write_reg(&H3c , &H0002)
Call Ili9325_write_reg(&H3d , &H1D04)
')
Call Ili9325_write_reg(&H30 , &H0000)
Call Ili9325_write_reg(&H31 , &H0707)
Call Ili9325_write_reg(&H32 , &H0307)
Call Ili9325_write_reg(&H35 , &H0200)
Call Ili9325_write_reg(&H36 , &H0008)
Call Ili9325_write_reg(&H37 , &H0004)
Call Ili9325_write_reg(&H38 , &H0000)
Call Ili9325_write_reg(&H39 , &H0707)
Call Ili9325_write_reg(&H3c , &H0002)
Call Ili9325_write_reg(&H3d , &H1D04)

'
Call Ili9325_write_reg(horizontal_add_start_position , &H0000)
Call Ili9325_write_reg(horizontal_add_end_position , &H00EF)
Call Ili9325_write_reg(vertical_add_start_position , &H0000)
Call Ili9325_write_reg(vertical_add_end_position , &H013F)
'
Call Ili9325_write_reg(driver_output_control_2 , &B0010_0111_0000_0000)
'
Call Ili9325_write_reg(&H61 , &H0001)
Call Ili9325_write_reg(&H6a , &H0000)

Call Ili9325_write_reg(partial_image_1_display_position , &H0000)
Call Ili9325_write_reg(partial_image_1_area_start_line , &H0000)
Call Ili9325_write_reg(partial_image_1_area_end_line , &H0000)
Call Ili9325_write_reg(partial_image_2_display_position , &H0000)
Call Ili9325_write_reg(partial_image_2_area_start_line , &H0000)
Call Ili9325_write_reg(partial_image_2_area_end_line , &H0000)


Call Ili9325_write_reg(&H90 , &H0013)
Call Ili9325_write_reg(&H92 , &H0000)
Call Ili9325_write_reg(&H07 , &H0133)
Cs_disp = 0
Rs_disp = 0
End Sub

#if Driver_mode = 8
'-------------------------------------------------------------------------------
' ILI9320_select_reg  Select an index register
'-------------------------------------------------------------------------------
Sub Ili9325_select_reg(byval Index As Byte )
      Cs_disp = 0
      Rs_disp = 0
      Data_disp = 0
      nop
      Wr_disp = 0
      nop
      Wr_disp = 1
      Data_disp = Index
      nop
      Wr_disp = 0
      nop
      Wr_disp = 1
      Cs_disp = 1
End Sub
'-------------------------------------------------------------------------------
' Ili9320_write_data  Write 16 Bit Data to Display
'-------------------------------------------------------------------------------
Sub Ili9325_write_data(byref Daten As Word)
     Cs_disp = 0
     Rs_disp = 1
     Data_disp = High(daten)
     nop
     Wr_disp = 0
     nop
     Wr_disp = 1
     Data_disp = Low(daten)
     nop
     Wr_disp = 0
     nop
     Wr_disp = 1
     Cs_disp = 1
End Sub
'-------------------------------------------------------------------------------
' Ili9325_write_reg  Write 16 Bit Data to Index Register
'-------------------------------------------------------------------------------
Sub Ili9325_write_reg(byval Index As Byte , Daten As Word)
      Cs_disp = 0
      Rs_disp = 0
      Data_disp = &H0                                       'VH
      Nop
      Wr_disp = 0
      nop
      Wr_disp = 1
      Data_disp = Index                                     'VL
      Nop
      Wr_disp = 0
      nop
      Wr_disp = 1
      Rs_disp = 1
      Data_disp = High(daten)                               'VH
      Nop
      Wr_disp = 0
      nop
      Wr_disp = 1
      Data_disp = Low(daten)                                'VL
      Nop
      Wr_disp = 0
      nop
      Wr_disp = 1
      Cs_disp = 1
End Sub
#endif

#if Driver_mode = 16
'-------------------------------------------------------------------------------
' ILI9320_select_reg  Select an index register
'-------------------------------------------------------------------------------
Sub Ili9325_select_reg(byval Index As Byte )
      Cs_disp = 0
      Rs_disp = 0
      Data_disp_high = 0

      Data_disp_low = Index

      Wr_disp = 0
      Wr_disp = 1
      Cs_disp = 1
End Sub
'-------------------------------------------------------------------------------
' Ili9320_write_data  Write 16 Bit Data to Display
'-------------------------------------------------------------------------------
Sub Ili9325_write_data(byref Daten As Word)
     Rgb16 = Daten
     Cs_disp = 0
     Rs_disp = 1
      Data_disp_high = Rgb16_high                           'High(daten)
      Data_disp_low = Rgb16_low                             'Low(daten)

     Wr_disp = 0
     Wr_disp = 1
     Cs_disp = 1
End Sub
'-------------------------------------------------------------------------------
' Ili9325_write_reg  Write 16 Bit Data to Index Register
'-------------------------------------------------------------------------------
Sub Ili9325_write_reg(byval Index As Byte , Daten As Word)
      Rgb16 = Daten
      Cs_disp = 0
      Rs_disp = 0
      Data_disp_high = &H00                                 'VH
      Data_disp_low = Index                                 'VL
      Wr_disp = 0
      Wr_disp = 1
      Rs_disp = 1
      Data_disp_high = Rgb16_high                           'High(daten)
      Data_disp_low = Rgb16_low                             'Low(daten)
      Wr_disp = 0
      Wr_disp = 1
      Cs_disp = 1
End Sub
#endif